import java.util.*;
import greenfoot.*;  

public class Cheats extends Actor implements Unbeweglich
{
    private List<String> eingaben = new ArrayList<String>();                //letzte 40 gedrückten Tasten
    private Map<String, String> ersetzen;   //verschiedene namen für die cheats
    public boolean muni;        //für jeden cheat eine boolean
    public boolean jetpack;
    public boolean schutz;
    public boolean spam;
    public boolean keineKollision;
    public boolean geschwindigkeit;
    public boolean keinScroll;
    public boolean all;
    
    public Cheats(){
    
        muni = false;        //alles deaktivieren
        jetpack = false;
        schutz = false;
        spam = false;
        keineKollision = false;
        geschwindigkeit = false;        
        keinScroll = false;
        all = false;
        
        mapStart();
        
        bild();
    
    }
    
    //Bild setzen
    public void bild(){
    
        Color durchsichtig = new Color(0,0,0,0);
        String text = "";                                                                                   //standartmässig kein Text
        int anzCheats = anzCheats();
        
        if (anzCheats > 0){                                                                                 //Wie viele Cheats an sind, wenn welche an sind
        
            text = (anzCheats == 7 ? "alle" : anzCheats) + " Cheat" + (anzCheats == 1 ? "" : "s");
        
        }
        
        GreenfootImage bild = new GreenfootImage(text, 18, Color.WHITE, durchsichtig);
        
        setImage(bild);
    
    }
    
    
    //aktivierte Cheats
    public int anzCheats(){
    
        int anz = 0;
        
        anz += muni ? 1 : 0;
        anz += jetpack ? 1 : 0;
        anz += schutz ? 1 : 0;
        anz += spam ? 1 : 0;
        anz += keineKollision ? 1 : 0;
        anz += geschwindigkeit ? 1 : 0;        
        anz += keinScroll ? 1 : 0;
        
        return anz;
    
    }
    
    //zusätzliche Cheatsnamen laden
    public void mapStart(){
    
        ersetzen = new HashMap<String, String>();
        
        ersetzen.put("rambo", "muni");
        ersetzen.put("ammo", "muni");
        ersetzen.put("rocketman", "jetpack");
        ersetzen.put("invul", "schutz");
        ersetzen.put("deadpool", "schutz");
        ersetzen.put("bulletstorm", "spam");
        ersetzen.put("noclip", "keinekollision");        
        ersetzen.put("sonic", "geschwindigkeit");
        ersetzen.put("speed", "geschwindigkeit");
        ersetzen.put("noscroll", "keinscroll");
        ersetzen.put("upupdowndownleftrightleftrightab", "all");
        ersetzen.put("konami", "all");
        ersetzen.put("dominanz1", "win1");
        ersetzen.put("dominanz2", "win2");
    
    }
    
    //alternative cheatnamen zu normalen ändern
    public String ersetzen(){
    
        String aus = eingabe();
        
        for(String s : ersetzen.keySet()){
            
            if(aus.endsWith(s))
                return ersetzen.get(s);
            
        }
            
        return aus;
    
    }
    
    //Tastendruck auf liste schreiben
    public void hinzu(String s){
    
        while(eingaben.size() >= 40)
            eingaben.remove(0);
            
        eingaben.add(s);
        
    }
    
    //Liste von Tastendrücken zu einem String
    public String eingabe(){
    
        String s = "";
        
        for(String temp : eingaben)
            s = s + temp;
        
        return s;
    
    }
    
    //nach Tastenanschlägen prüfen, auf die Liste schreiben (wenn vorhanden) und zurückgeben, ob eine gedrückt wurde
    public boolean tasten(){
    
        String taste = Greenfoot.getKey();
        
        if(taste != null){
        
            hinzu(taste);
            return true;
        
        }
    
        return false;
        
    }
    
    //verschiedene Cheats aktivieren abhängig von den letzten Tastenanschlägen
    public boolean aktivieren(){
    
        String s = ersetzen();
        
        if(s.endsWith("muni")){
        
            muni = !muni;
            return true;
        
        }
        
        if(s.endsWith("jetpack")){
        
            jetpack = !jetpack;
            return true;
        
        }
        
        if(s.endsWith("schutz")){
        
            schutz = !schutz;
            return true;
        
        }
        
        if(s.endsWith("spam")){
        
            spam = !spam;
            return true;
        
        }
        
        if(s.endsWith("keinekollision")){
        
            keineKollision = !keineKollision;
            return true;
        
        }
        
        if(s.endsWith("geschwindigkeit")){
        
            geschwindigkeit = !geschwindigkeit;
            
            MyWorld.spieler1.setGeschwindigkeit(geschwindigkeit ? 4 : 2);
            if(MyWorld.spieleranzahl == 2)MyWorld.spieler2.setGeschwindigkeit(geschwindigkeit ? 4 : 2);
            return true;
        
        }
        
        if(s.endsWith("keinscroll")){
        
            keinScroll = !keinScroll;
            return true;
        
        }
        
        if(s.endsWith("all")){
            
            all = !all;
            
            muni = all;
            jetpack = all;
            schutz = all;
            spam = all;
            keineKollision = all;
            geschwindigkeit = all;
            keinScroll = all;
            
            MyWorld.spieler1.setGeschwindigkeit(geschwindigkeit ? 4 : 2);
            if(MyWorld.spieleranzahl == 2)MyWorld.spieler2.setGeschwindigkeit(geschwindigkeit ? 4 : 2);
            
            return true;
        
        }
        
        if(s.endsWith("win1")){
        
            getWorld().addObject(new Ziel("Spieler 1 "), MyWorld.spieler1.getX(), MyWorld.spieler1.getY());
            return true;
        
        }
        
        if(s.endsWith("win2")){
        
            getWorld().addObject(new Ziel("Spieler 2 "), MyWorld.spieler1.getX(), MyWorld.spieler1.getY());
            return true;
        
        }
        
        return false;
    
    }
    
    //eingabe leeren
    public void clear(){
    
        eingaben = new ArrayList<String>();
    
    }
    
    public void act(){
        
        if(!tasten())   //rechenleistung sparen wenn keine Taste gedrückt wurde
            return;
            
        if(aktivieren()){    //eingabeverlauf leeren, wenn cheat aktiviert wird und text updaten
            clear();
            bild();
        }
        
    }
    
}
