import greenfoot.*;  

public class Mensch extends Actor
{
    private double schwerkraft = MyWorld.schwerkraft;                               //Variable für die Schwerkraft, welche auf die Objekte wirkt (welche man aus MyWorld holt; ist eine statische Variable in MyWorld)
    protected double vGeschwindigkeit = 0;                                          //Variable für die vertikale Geschwindigkeit
    private int geschwindigkeit ;                                                   //Variable für die horizontale Geschwindigeit
    private int schutz = 0;                                                         //Variable für die Unsterblichkeit, nach dem Tod
    public Mensch()
    {
        this.geschwindigkeit=2;                                                     //Horizontale Geschwindigkeit wird 2 gesetzt
    }
    
    
    public void act() 
    {
        fallen();                                                                   //Schwerkraft auf die Objekte wird ausgeführt
        loeschen();                                                                 //Objekt löscht sich selbst, wenn es zu weit ins Offset gerät
        if(schutz>0)                                                                //Unsterblichkeit wird bei jedem Tick, bis auf 0, reduziert
            schutz --;
    }   
    public void fallen()                                                            //Funktion der Schwerkraft
    {
        vGeschwindigkeit += schwerkraft;                                            //Geschwindigkeit wird stets um die Beschleunigung (vom Konstruktor) erhöht
        boolean vPositiv = vGeschwindigkeit>0;                                      //Fallunterscheidung, ob man springt, oder fällt
        if (vGeschwindigkeit==0) return;                                            //Funktion beenden, wenn sowieso nichts geschieht
        if(!vPositiv)                                                               //Funktion in welcher das Objekt "fällt"
        {for(int v=0; v<(Math.abs((int) vGeschwindigkeit)); v++)                    //Wurde in eine for Schlaufe gesetzt, um zu verhindern, dass min in den boden hinein fällt
        {
            if(falltest())                                                          //man fällt nur, wenn man nicht auf einem Objekt der Klasse Boden steht
                {
                setLocation(getX(), getY() + 1);
            }
            else                                                                    //sobald man drauf steht, wird die Schlaufe beendet (eigentlich nicht nötig, spart aber Leistung)
                break;
            }
        }
        else
        {
            for(int v=0; v<(Math.abs((int) vGeschwindigkeit)); v++)                //Funktion in der das Objekt springt
                {
            
                
                setLocation(getX(), getY() - 1);
            
            
            }
        }
    }
    public boolean aufPlatform()                                                                //Prüfung, ob das Objekt auf dem Boden steht
    {
        Actor plattform = getOneObjectAtOffset(0, getImage().getHeight()/2, Boden.class);       //es wird nach dam Boden unter dem Objekt gesucht
        return plattform != null && vGeschwindigkeit < 0;                                       //wenn ein Bodenelement vorhanden ist, gibt es true zurück und setzt gleichzeitig die Fallgeschwindigkeit 0
        
    }
    
    public boolean aufBoden()                                                                   //Prüfung, ob das Objekt sich im Bild befindet (nicht in ein loch gefallen ist)
    {
        return getY()+getImage().getHeight()/2>=getWorld().getHeight()+5;                       //gibt true zurück, wenn das objekt aus der Welt fällt (>= um eventuelle Bugs zu verhindern)
    }
    
    public boolean falltest()                                                                   //Prüfung ob das Objekt fallen kann und gerade Aktionen ausführt, wenn dies nicht der Fall ist
    {
        
        if(aufBoden() && this instanceof Spieler)                                               //Prüfung ob es sich um ein Spieler handelt und ob dieser gearade aus der Welt fällt
        {
           tod();                                                                               //tötet den Spieler
           return false;                                                                        //gibt false zurück, dass der Spieler beim respawnen nicht direkt fällt
        }
        else
        {
             if(!aufPlatform())                                                                 //prüft ob das Objekt nicht auf dem Boden steht
            {
                
                
                return true;                                                                    //gibt true zurück, damit das Objekt fallen kann
            }
            else
           {
            if(getOneObjectAtOffset(0, getImage().getHeight()/2,Boden.class) != null && !(this instanceof Spieler && MyWorld.cheats.keineKollision))           //Methode die gebraucth wird um einen Bug zu fixen (man kan seitlich in den Dreck hinein glitchen, auch wenn man nicht auf der richtigen Höhe steht und dem entsprechend im Dreck stecken)
                    setLocation(getX(), getOneObjectAtOffset(0, getImage().getHeight()/2,Boden.class).getY()-50-getImage().getHeight()/2); // Wenn der Bug passiert, wird man einfach auf den Dreck hinauf gesetzt, wird selbst verständlich beim "keine Kollison" cheat selbst verständlich nicht ausgeführt
            vGeschwindigkeit = 0;                                                               //Fallgeschwindigkeit wird 0 gsestzt, da man ja auf dem Boden steht
            return false;                                                                       //false wird zurück gegeben, damit man nicht in den Boden hineni fällt
            }
        }
        
    }
    
    public void rechtsBewegung()                                                                    //Funktion für die Bewegung nach rechts
    {
        for(int i = 0; i<geschwindigkeit + 1; i++)                                                    //Funktion wird in eine for Schlaufe gesetzt, um zu verhindern, dass man in eine Wand hinein läuft
        {
            Actor plattform = getOneObjectAtOffset(getImage().getWidth()/2, 0, Boden.class);        //Prüft, ob eine Wand rechts vorhanden ist
            if(plattform == null || (this instanceof Spieler && MyWorld.cheats.keineKollision))     //wenn keine da ist, bewegt man sich (bei keine Kollision cheat bewegt man sich immer)
                setLocation( getX() + 1, getY() );
            else                                                                                    //Sobald eine Wand da ist, wird die Schlaufe beendet (eigentlich nicht nötig, spart aber Leistung)
                break;
        }
    }
    
    public void linksBewegung()                                                                     //Funktion für die Bewegung nach links
    {
        for(int i = 0; i<geschwindigkeit; i++)                                                      //Funktion wird in eine for Schlaufe gesetzt, um zu verhindern, dass man in eine Wand hinein läuft
        {
            Actor plattform = getOneObjectAtOffset(-getImage().getWidth()/2, 0, Boden.class);       //Prüft, ob eine Wand links vorhanden ist
            if(plattform == null || (this instanceof Spieler && MyWorld.cheats.keineKollision))     //wenn keine da ist, bewegt man sich (bei keine Kollision cheat bewegt man sich immer)
                setLocation( getX() - 1, getY() );
            else                                                                                    //Sobald eine Wand da ist, wird die Schlaufe beendet (eigentlich nicht nötig, spart aber Leistung)
                break;
        }
    }
    
    public void tod()                                                                               //Funktion für das Töten eines Spielers
    {
    
        if(schutz == 0 && !MyWorld.cheats.schutz){                                                  //überprüfen nach der Unverwundbarkeit (Cheat und Schutzzeit)
            setLocation(getWorld().getWidth()/2, getWorld().getHeight()/2-50) ;                     //Spieler wird in die Mitte der Welt gesetzt
        if(this == MyWorld.spieler1)                                                                //Unterscheidung welcher der 2 Spieler gestorben ist
            MyWorld.punkte1 = MyWorld.punkte1/2;                                                    //Punkte des gestorbenen Spielers halbieren
        else
            MyWorld.punkte2 = MyWorld.punkte2/2;                                                    //Punkte des gestorbenen Spielers halbieren
        vGeschwindigkeit=5;                                                                         //Spieler nach Tod nach oben springen lassen(damit man zeit hat, um zu reagieren, wenn man über einem Loch spawnt
        Greenfoot.playSound("au.wav");                                                              //Todessound abspielen
        getWorld().removeObjects(getIntersectingObjects(Gegner.class));                             //Gegner die sich im respawnten Spieler befinden löschen, um respawn loops zu verhindern
        getWorld().removeObjects(getIntersectingObjects(Projektil.class));                          //Projektile die sich im respawnten Spieler befinden löschen, um respawn loops zu verhindern
        schutz = 20;  }                                                                              //unverwundbarkeit auf 40 Ticks setzen
    
    
    }
    
    public void loeschen()                                                                          //Funktion für das Löschen aller Objekte, welche sich ausserhalb sdes Bildschirms befinden (um Leistung zu sparen)
    {
        if(this instanceof Spieler)                                                                 //Prüft, ob das Objekt ein Spieler ist
        {
            if(getX()<1)                                                                            //für Spieler bedeutet der Weltrand der Tod, daher eine abprüfung auf den Weltrand
                tod();                                                                              //Spieler stirbt
        }
        else{
        if(getX()<-499)                                                                             //sonst gilt für alle andern Objekte -499 als Grenze
        {
            getWorld().removeObject(this);                                                          //wenn sie diese Grenze überschreiten, werden sie gelöscht
        }}
    }
    
    public void setGeschwindigkeit(int i)                                                           //set Funktion für die Geschwindigkeit (wird ausschliesslich für cheats gebraucht)
    {
        geschwindigkeit = i;
    }
}
