import greenfoot.*;
import java.util.*;

public class Projektil extends Mensch
{
    
    private double geschwindigkeit;                                                             //Variable für die Projektilgeschwindigkeit
    private boolean richtung;                                                                   //Variable für die Richtung (true bedeutet rechts)
    private Class ziel;                                                                         //Variable für die Zielklasse, die das Projektil töten soll
    private Spieler spieler;                                                                    //Variable für den Spieler, welcher das Projektil abgefeuert hat
    private boolean vorhanden = true;                                                           //Variable um fehler zu verhindern
    public Projektil(double geschwindigkeit, boolean richtung, Class ziel, Spieler spieler){    
    
        this.geschwindigkeit = geschwindigkeit;                                                 //Variable wird vom Konstruktor für die Klasse übernommen
        this.richtung = richtung;                                                               //Variable wird vom Konstruktor für die Klasse übernommen
        this.ziel = ziel;                                                                       //Variable wird vom Konstruktor für die Klasse übernommen
        this.spieler = spieler;                                                                 //Variable wird vom Konstruktor für die Klasse übernommen
        setImage(richtung ? "Projektilrechts.png" : "Projektillinks.png");                      //Bild wird hier gesetzt ( wenn richtung true ist, das Bild nach rechts)
    }
    
    public void act(){
        bewegen();                                                                              //Funktion für das Bewegen
        selbstLoeschen();                                                                       //Funktion, um sich selbst zu löschen, wenn das Projektil zu weit ins offset gerät, oder wenn es auf eine Wand trifft (um Leistung zu sparen)
        if(getWorld() != null)
            toeten();                                                                           //Funktion um das getroffenen Objekt zu töten, sich selbst zu entfernen unf je nach dem dem Spieler die Punkte geben
    }
    
    public void bewegen()                                                                       //Funktion für das Bewegen des Projektisls
    {
        if(richtung)                                                                            //Abfrage nach der Richtung
        {
            rechtsBewegung();                                                                   //in Mensch definiert
            rechtsBewegung();
        }
        else
        {
            linksBewegung();                                                                    //in Mensch definiert
            linksBewegung();
        }
    }
    
    public void toeten()
  
        {
        List <Actor> zuToeten = getObjectsInRange(20, ziel);                            //Liste mit getroffenen Objekten(getroffen werden nur Objekte der Klasse ziel, welche im Konstruktor gegeben ist)
        if(!zuToeten.isEmpty())                                                         //Prüft, ob etwas getroffen wurde
        {
            for(Actor tod : zuToeten)                                                   //Geht die Liste der getroffenen Objekte durch
            {
                if(tod instanceof Spieler)                                              //Prüft ob ein Spieler getroffen wird
                ((Mensch)tod).tod();                                                    //Actor wird zur Klasse Mensch gecastet und schnschliessend wird die Methode tod ausgeführt (in Mensch definiert
                else
                    getWorld().removeObjects(zuToeten);                                 //wenn es kein Mensch ist, wird das Objekt entfernt
            
            if(spieler == MyWorld.spieler1)                                             //Punkte werden für den Spieler hinzugefügt, der das Projektil geschossen hat (wenn ein Gegner das Projektil schiesst ist spieler null und somit nicht gleich wie spieler1 oder spieler2
                MyWorld.punkte1 += 20;
            if(spieler == MyWorld.spieler2)
                MyWorld.punkte2 += 20;
            }
            if(getWorld() != null)                                                            //sehr komischen Crash Fixen (es scheint, alsob es manchmal null wär)
                getWorld().removeObject(this);                                          //Projektil entfernt sich selbst
            if(spieler != null)                                                         //wenn ein Spieler mit dem Projektil etwas trifft, wird der Explosionssound gespielt
            Greenfoot.playSound("explosion.wav");
        }
    }
    
    
    public void selbstLoeschen()
    {
       boolean rechts = getOneObjectAtOffset(getImage().getWidth()/2 + 10, 0, Boden.class) != null;         //Variable, ob rechts eine Wand ist
       boolean links = getOneObjectAtOffset(- (getImage().getWidth()/2) - 10, 0, Boden.class) != null;      //Variable, ob links eine Wand ist
       List<Projektil> bugs = getIntersectingObjects(Projektil.class);                                      // 1. bugfix 2. wird das vom Spieler geschossene projektil gelöscht, wenn es auf ein gegnerisches trifft und man bekommt die munition zurück
       if(getX()<-600 || getX()>1200){                                                                      //Projektil löscht sich selbst, wenn es zu weit ins Offset gerät (um Leistung zu sparen)
            getWorld().removeObject(this);
            vorhanden = false;}
       if(rechts && vorhanden){                                                                             //Projektil löscht sich selbst, wenn es auf eine Wand trifft
            getWorld().removeObject(this);
            vorhanden = false;}
       if(links && vorhanden){                                                                              //Projektil löscht sich selbst, wenn es auf eine Wand trifft
            getWorld().removeObject(this);
            vorhanden = false;}
       if(!bugs.isEmpty() && spieler != null && vorhanden && !MyWorld.cheats.spam){                                                 //Bugfix und das Projektil löscht sich selbst, wenn es auf ein gegnerisches Projetkil stösst
           spieler.munition ++;                                                                             //man erhält dabei die Munition zurück
           getWorld().removeObject(this);
           vorhanden = false;}
       
    }
}
