import greenfoot.*;
import java.util.*;

public class Scroller extends World
{
    public static double zaehler = 0;       //zähler wie viele ticks die Welt gemacht hat, bzw. wie weit "gescrollt" wurde
    private int SCROLLSPEED= -1;            // wie schnell "gescrollt" wird
    public static final int BREITE = 600;   //Breite der Welt
    public static final int HOEHE = 400;    //Höhe der Welt

    
    
    
    
    
    public Scroller(int breite, int hoehe, int raster, boolean randkontakt)     //Konstruktor für "Scroller"
    {    
        super(breite, hoehe, raster, randkontakt);                              //Konstruktor für "World"
        hintergrund();                                                          //Hintergrund für Startbildschirm und nächsten Bildschirm setzen
        zaehler=0;                                                              //zähler 0 setzen, um bugs zu verhindern

    }
    
    public void act()
    {
        scrollen(SCROLLSPEED);              //die welt wird hier "gescrolt", also um "SCROLLSPEED" pixel nach links verschoben
        zaehler ++;                         //zähler wird pro tick erhöht
    }
    
    public void scrollen(int tempo) 
    {
        
        List<Actor> actors = getObjects(Actor.class);                                               //hohlt alle objekte in der Welt
        for (Actor actor : actors) {
            if (actor instanceof Unbeweglich) {                                                     //alle Objekte, welche das Interface "Unbeweglich" implementieren, werden nicht bewegt
                
            }
            else {
                double multiplikator = 1;                                                           //wieviel mal "SCROLLSPEED" multipliziert wird
                if(actor instanceof ScrollGeschwindigkeit)                                          //"ScrollGeschwindigkeit" ist das Interface, welches implementiert wird, um die Hintergründe verschieden schnell laufen zu lassen (multiplikator setzen)
                    multiplikator = ((ScrollGeschwindigkeit) actor).gibMultiplikator();             // multiplikator wird gesetzt
                
                //der multiplikator kann auch dezimalzahlen als Werte haben
                double temp = multiplikator - Math.floor(multiplikator);                
                if(temp != 0){
                    
                    double r = (new Random()).nextGaussian();
                    r *= r < 0 ? -1 : 1;
                    multiplikator += r <= temp ? 1 : 0;                                             //der nicht ganzzahlige Rest wird durch mit einer Wahrscheinlichkeit hinzugefügt
                    
                }
                
                multiplikator *= multiplikator < 0 ? -1 : 1;                                        //unerklärlicher Bug! dieser Wert scheint negativ zu werden
                
                actor.setLocation(actor.getX() + ((int) (tempo*multiplikator)), actor.getY());      //alle Objekte werden um "SCROLLSEED" mal "multiplikator" pixel nach links verschoben 
            }
        }
        
    }
    
    public void hintergrund()
    {
        Hintergrund[] schichten = {new Schicht1(), new Schicht1(), new Schicht2(), new Schicht2(), new Grund(), new Grund()};   //je 2 Hintergründewerden produziert (ein für 1. Bilschirm, ein für 2. Bildschirm)
        
        for (int i = 0 ; i<2; i+=2) {                                                                                           //Erste Schicht wird gesetzt (Himmel)
            addObject(schichten[i],BREITE/2,HOEHE/2);
            addObject(schichten[i+1],BREITE/2 + BREITE,HOEHE/2);
            
        }
        
        Wolken[] wolken = new Wolken[25];                                                                                       //Array mit lauter Hintergrundwolken wird generiert
        for(int k = 0; k<wolken.length ; k++)                                                                                   //Array wird gefüllt
            {
                wolken[k] = new Wolken();
            }
        
        for( int i = 0 ; i<12 ; i++)                                                                                            //12 Wolken werden Generiert
            {
                if((new Random()).nextInt(4)>0)                                                                                 //Jede Wolke wird zu 75% generiert
                    addObject(wolken[i],BREITE/6+100*i,HOEHE-100-wolken[i].getImage().getHeight()/2-Greenfoot.getRandomNumber(200));
            
            }
        
        
        for (int i = 2 ; i<4; i+=2) {                                                                                           //Zweite Schicht wird gesetzt(Berg)
            addObject(schichten[i],BREITE/2 + BREITE,HOEHE-40-schichten[i].getImage().getHeight()/2);
            
        }
        
        for (int i = 4 ; i<6; i+=2) {                                                                                           //Vierte schicht wird gesetzt(Kiesboden)
            addObject(schichten[i],BREITE/2,HOEHE/2);
            addObject(schichten[i+1],BREITE/2 + BREITE,HOEHE/2);
            
        }

        Schicht3[] schichten3 = new Schicht3[25];                                                                               //Array mit lauter Hintergrundbäumen wird generiert
        for(int k = 0; k<schichten3.length ; k++)                                                                               //Array wird gefüllt
            {
                schichten3[k] = new Schicht3();
            }
        
        for( int i = 0 ; i<24 ; i++)                                                                                            //24 Bäume werden Generiert
            {
                if((new Random()).nextInt(3)>0)                                                                                 //Jeder Baum wird zu 66% generiert
                    addObject(schichten3[i],BREITE/12-25+50*i,HOEHE-100-schichten3[i].getImage().getHeight()/2);
            
            }
            }
    }
    
    

