import greenfoot.*;  
import java.util.*;

public class Spieler extends Mensch implements ScrollGeschwindigkeit
{
    
    private String sprung;                                                      //Variable für die Tastenbelegung
    private String landen;                                                      //Variable für die Tastenbelegung
    private String links;                                                       //Variable für die Tastenbelegung
    private String rechts;                                                      //Variable für die Tastenbelegung
    private String schiessen;                                                   //Variable für die Tastenbelegung
    private String schlagen;                                                    //Variable für die Tastenbelegung                                          
    private int huepfGeschwindigkeit = 6;                                       //Variable für die Geschwindigkeit, welche man bekommt, wenn man hüpft
    private GreenfootImage rechts1;                                             //Bilder werden initialisiert
    private GreenfootImage rechts2;
    private GreenfootImage links1;
    private GreenfootImage links2;
    private int schussZahl = 0;                                                 //Zähler für Schuss cooldown
    private int schlagZahl = 0;                                                 //Zähler für Schlag cooldown
    private boolean richtung = true;                                            //Variable für die Richtung, in welche der Spieler zeigt
    private boolean laufanimation = true;                                       //Variable für das Wechseln der BIlder für eine Laufanimation
    private int animationszaehler = 0;                                          //Variable für den Abstand zwischen dem Wechseln der Bilder für die Laufanimation
    public int munition;                                                     //Variable für die Munition/Schüsse
    public int schlagMunition;                                               //Variable fur wie viele Schläge man hat
    
    public Spieler(String sprung, String landen, String links, String rechts, String schiessen, String schlagen)
    {
        if(this == MyWorld.spieler1){                                           //Bilder für Spieler 1 werden gesetzt
        rechts1 = new GreenfootImage("menschrechtsstehend1.png");
        rechts2 = new GreenfootImage("menschrechts1.png");
        links1 = new GreenfootImage("menschlinksstehend1.png");
        links2 = new GreenfootImage("menschlinks1.png");}
        else{                                                                   //Bilder für Spieler 2 werden gesetzt
        rechts1 = new GreenfootImage("menschrechtsstehend2.png");
        rechts2 = new GreenfootImage("menschrechts2.png");
        links1 = new GreenfootImage("menschlinksstehend2.png");
        links2 = new GreenfootImage("menschlinks2.png");
        }
        this.sprung= sprung;                                                    //Variablen werden vom Konstruktor übernommen
        this.landen= landen;
        this.links= links;
        this.rechts= rechts;
        this.schiessen= schiessen;
        this.schlagen= schlagen;                                          
        if(this == MyWorld.spieler1)                                            //Bild des Spielers wird gesetzt
            setImage("menschrechtsstehend1.png");
            else
            setImage("menschrechtsstehend2.png");
        schlagMunition= 10;                                                     //Munition wird auf den Startwer gesetzt
        munition = 10;
    }
    public void act() 
    {
        super.act();                                                            //act von "Mensch" ausführen
        steuerung();                                                            //Funktion für das bewegen,schlagen und schiessen
        punkteEinsammeln();                                                     //Funktion für das Einsammeln von Objekten, welche Punkte geben
    }
    public void steuerung()
    {
        if (Greenfoot.isKeyDown(rechts))                                        //Funktion für die Bewegung nach Rechts
        {
           rechtsBewegung();                                                    //Beweging nach Links (in "Mensch" definiert)
           richtung = true;                                                     //Richtung in welche der Spieler zeigt setzen
           pendelnRechts();                                                     //pendelnde Laufanimation ausführen
        }
        else
        {
            if(richtung)                                                        //Prüft, ob man nach Rechts steht
                if(this == MyWorld.spieler1 )                                    //Prüft, welcher Spieler es ist
                    setImage("menschrechtsstehend1.png");                       //setzt Bild auf stehend, wenn man sich nicht bewegt
                else
                    setImage("menschrechtsstehend2.png");                       //setzt Bild auf stehend, wenn man sich nicht bewegt
        }
        if (Greenfoot.isKeyDown(links))                                         //Funktion für die Bewegung nach Links
        {
            linksBewegung();                                                    //Beweging nach Links (in "Mensch" definiert)
            richtung = false;                                                   //Richtung in welche der Spieler zeigt setzen
            pendelnLinks();                                                     //pendelnde Laufanimation ausführen
        }
        else
        {
            if(!richtung)                                                       //Prüft, ob man nach Links steht
                if(this == MyWorld.spieler1)                                    //Prüft, welcher Spieler es ist
                    setImage("menschlinksstehend1.png");                        //setzt Bild auf stehend, wenn man sich nicht bewegt
                else
                    setImage("menschlinksstehend2.png");                        //setzt Bild auf stehend, wenn man sich nicht bewegt
        }
        if (Greenfoot.isKeyDown(sprung))                                        //Funktion für das Hüpfen
        {
            huepfen();                                                          //Funktion für das Hüpfen nach Oben (in "Mensch" definiert)
        }
        if (Greenfoot.isKeyDown(landen)){                                        //Funktion für das schnellere Landen
            vGeschwindigkeit -= 4;                                              //erniedrigt vertikale Geschwindigkeit(in "Mensch" definiert)

            if(aufPlatform() && MyWorld.cheats.keineKollision)
                setLocation(getX(), getY() + 1);

        }
        if (Greenfoot.isKeyDown(sprung) && MyWorld.cheats.jetpack && vGeschwindigkeit < 3)              //Jetpack bei aktiviertem Cheat
            vGeschwindigkeit = 3;
        
        if (Greenfoot.isKeyDown(schiessen))                                     //Funktion für das Schiessen
        {
            schiessen();                                                        //Funktion für das Schiessen
        }
        else
            schussZahl++;                                                       //Setzt den Zähler um 1 höher ( verringert den Cooldown um 1)
        if (Greenfoot.isKeyDown(schlagen))                                      //Funktion für das Schlagen
        {
            schlagen();                                                         //Funktion für das Schlagen
        }
        else
            schlagZahl++;                                                       //Setzt den Zähler um 1 höher ( verringert den Cooldown um 1)
    }
    
    public void huepfen()
    {
        
        if(aufPlatform())                                                       //Prüft, ob der Spieler auf einer Plattform steht (in "Mensch" definiert)
            vGeschwindigkeit = huepfGeschwindigkeit;                            //setzt vertikale Geschwindigkeit auf die Hüpfgeschwindigkeit
        
    }
    
    
    public void punkteEinsammeln()
    {
       List<Punkte> eingesammelt = getIntersectingObjects(Punkte.class);        //Liste mit allen Objekten der Klasse "Punkte", welche man einsammelt
       for(Punkte objekt : eingesammelt)                                        //Geht Liste eingesammelt durch
       {
           if(objekt instanceof Pilz)                                           //Prüft, ob es sich um ein Pilz handelt
           {
               if(this == MyWorld.spieler1)                                     //erhöht die Punkte des Spielers, der den Pilz eingesmmaelt hat
                   MyWorld.punkte1 += 10;
               else
                   MyWorld.punkte2 += 10; 
            }
           
           if(objekt instanceof Erdbeere)                                       //Prüft, ob es sich um eine Erdbeere handelt
           {
               if(this == MyWorld.spieler1)                                     //erhöht die Punkte des Spielers, der den Pilz eingesmmaelt hat
                   MyWorld.punkte1 += 20;
               else
                   MyWorld.punkte2 += 20; 
            }
            
           getWorld().removeObject(objekt);                                     //löscht das eingesammelte Objekt
        }
    }
    
    public void schlagen()
    {
        if((schlagZahl>=20 || (MyWorld.cheats.spam && schlagZahl>=5)) && (schlagMunition > 0 || MyWorld.cheats.muni))       //Prüft, ob ein Schlag ausgeführt werden kann
        {
        List<Mensch> getroffen = getObjectsInRange(80,Mensch.class);            //Liste mit allen getroffenen Objekten
        getroffen.removeAll(getObjectsInRange(80,Spieler.class));               //Spierer werden aus der Liste entfernt, dass man sich selbst, oder den anderen Spieler nicht treffen kann
        Greenfoot.playSound("Schwert.mp3");                                     //Schlagsound wird abgespielt
        for(Mensch tod : getroffen)                                             //Geht Liste der getroffenen Objekte durch
        {
            tod.getWorld().removeObject(tod);                                   //entfernt das getroffene Objekt aus der Welt
            if(tod instanceof Gegner)                                           //Prüft, ob es sich um ein Gegner handlet
               { if(this == MyWorld.spieler1)                                   //Fügt dem Spieler, der geschlagen hat, die Punkte hinzu
                   MyWorld.punkte1 += 30;
               else
                   MyWorld.punkte2 += 30;}
            else
                munition++;                                                     //wenn es kein Gegner war, so muss es ein Projektil gewasen sein und man erhalt ein Schuss, pro getroffenes Projektil
        }
        schlagMunition -= MyWorld.cheats.muni ? 0 : 1;                          //Schlagmunition wird um 1 hinunter gesetzt/ ein Schlag wird verbraucht (nur wenn der Cheat aus ist)
        schlagZahl = 0;                                                         //Cooldown wird auf 0 gesetzt
       }
       schlagZahl++;                                                            //Cooldown wird um 1 gesenkt
    }
    
    public void schiessen()
    {
        if((schussZahl>=30 || (MyWorld.cheats.spam && schussZahl>=5)) && (munition>0 || MyWorld.cheats.muni))                                                            //Prüft, ob ein Schuss ausgeführt werden kann
        {
            
            Projektil[] projektileRechts = {new Projektil(5,true,Gegner.class,this)};               //Array für alle Schüsse nach Rechts wird generiert
            Projektil[] projektileLinks = {new Projektil(5,false,Gegner.class,this)};               //Array für alle Schüsse nach Links wird generiert
            
            if(richtung)                                                                            //Prüft, in welche Richtung geschossen wird
                getWorld().addObject(projektileRechts[0],getX()+getImage().getWidth()/2,getY());    //Generiert das Projektil
            else
                getWorld().addObject(projektileLinks[0],getX()-getImage().getWidth()/2,getY());     //Generiert das Projektil
            Greenfoot.playSound("Schuss.wav");                                                      //Schusssound wird abgespielt
            munition -= MyWorld.cheats.muni ? 0 : 1;                                                //Munition wird um eins gesenkt/Munition wird verbraucht (nur wenn der Cheat aus ist)
            schussZahl = 0;                                                                         //Cooldown wird auf 0 gsestzt
        }
        schussZahl++;                                                                               //Cooldown wird um 1 gesenkt
    }
    
    public void pendelnRechts()                                                                     //Funktion für die pendelnde Laufanimation
    {
        if(animationszaehler >= 5)                                                                  //Prüft, ob es das Bild ändern soll
        {
            laufanimation = !laufanimation;                                                         //Variable, um das bild zu wechesln, wird geändert
            animationszaehler = 0;                                                                  //Zähler wird auf 0 gesetzt
        }
            if(this == MyWorld.spieler1)                                                            //Prüft, um welchen Spieler es sich handelt
        {
            if(laufanimation)                                                                       //Funktion, um das Bild zu ändern
                setImage("menschrechts1.png");
            else
                setImage("menschrechtsstehend1.png");
        }
        else
        {
            if(laufanimation)                                                                       //Funktion, um das Bild zu ändern
                setImage("menschrechts2.png");
            else
                setImage("menschrechtsstehend2.png");
        }
        animationszaehler ++;                                                                       //Zähler wird um 1 erhöht
    }
    
    public void pendelnLinks()                                                                      //Funktion für die pendelnde Laufanimation
    {
        if(animationszaehler >= 5)                                                                  //Prüft, ob es das Bild ändern soll
        {
            laufanimation = !laufanimation;                                                         //Variable, um das bild zu wechesln, wird geändert
            animationszaehler = 0;                                                                  //Zähler wird auf 0 gesetzt
        }
            if(this == MyWorld.spieler1)                                                            //Prüft, um welchen Spieler es sich handelt
        {
            if(laufanimation)                                                                       //Funktion, um das Bild zu ändern
                setImage("menschlinks1.png");
            else
                setImage("menschlinksstehend1.png");
        }
        else
        {
            if(laufanimation)                                                                       //Funktion, um das Bild zu ändern
                setImage("menschlinks2.png");
            else
                setImage("menschlinksstehend2.png");
        }
        animationszaehler ++;                                                                       //Zähler wird um 1 erhöht
    }
    
    public double gibMultiplikator(){                                               //Deaktiviert das Scrollen, wenn der Cheat an ist
        return MyWorld.cheats.keinScroll ? 0 : 1;
    }
}
 
    
    

